// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package research_projects

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new research projects API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for research projects API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	CreateResearchProject(params *CreateResearchProjectParams, opts ...ClientOption) (*CreateResearchProjectCreated, error)

	DeleteResearchProject(params *DeleteResearchProjectParams, opts ...ClientOption) (*DeleteResearchProjectNoContent, error)

	GetResearchProjects(params *GetResearchProjectsParams, opts ...ClientOption) (*GetResearchProjectsOK, error)

	UpdateResearchProject(params *UpdateResearchProjectParams, opts ...ClientOption) (*UpdateResearchProjectOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
CreateResearchProject creates a new research project
*/
func (a *Client) CreateResearchProject(params *CreateResearchProjectParams, opts ...ClientOption) (*CreateResearchProjectCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewCreateResearchProjectParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "createResearchProject",
		Method:             "POST",
		PathPattern:        "/researchprojects",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &CreateResearchProjectReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*CreateResearchProjectCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for createResearchProject: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
DeleteResearchProject deletes a research project
*/
func (a *Client) DeleteResearchProject(params *DeleteResearchProjectParams, opts ...ClientOption) (*DeleteResearchProjectNoContent, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteResearchProjectParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "deleteResearchProject",
		Method:             "DELETE",
		PathPattern:        "/researchprojects",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteResearchProjectReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteResearchProjectNoContent)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteResearchProject: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
GetResearchProjects gets a list of research projects
*/
func (a *Client) GetResearchProjects(params *GetResearchProjectsParams, opts ...ClientOption) (*GetResearchProjectsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetResearchProjectsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getResearchProjects",
		Method:             "GET",
		PathPattern:        "/researchprojects",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetResearchProjectsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetResearchProjectsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getResearchProjects: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
UpdateResearchProject updates an existing research project
*/
func (a *Client) UpdateResearchProject(params *UpdateResearchProjectParams, opts ...ClientOption) (*UpdateResearchProjectOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewUpdateResearchProjectParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "updateResearchProject",
		Method:             "PUT",
		PathPattern:        "/researchprojects",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &UpdateResearchProjectReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*UpdateResearchProjectOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for updateResearchProject: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
